unit Philosofer;
interface
uses
  Classes, Windows, Graphics, ExtCtrls,SysUtils;
type
  Philosophers = class(TThread)
  private
    procedure think;
    procedure eat;
    procedure take_stick;
    procedure put_stick;
    procedure test(i:integer);
    function FindNumber:integer;
  protected
    procedure Execute; override;
  end;
implementation
uses Unit1;

//  
procedure Philosophers.Execute;
begin
while (not Terminated) do begin //    :
take_stick;                 //     ()
eat;                            // 
put_stick;                  //  
think;                        // 
end;
end;

//  
procedure Philosophers.think;
begin
sleep(Random(10000)); //    10 .
end;

//      
procedure Philosophers.take_stick;
var i:integer;
Sh:TShape;
begin
i:=FindNumber; //       
Sh:=TShape(Form1.FindComponent('F'+IntToStr(i)+'Shape')); //  
EnterCriticalSection(CriticalSection); //    
//WaitForSingleObject(mutex,INFINITE); //     
try
state[i]:=phHungry;    // ,    
Sh.Brush.Color:=clRed; //    
test(i);               //   
finally
LeaveCriticalSection(CriticalSection); //    
//ReleaseMutex(mutex);                 //     
WaitForSingleObject(semaphore[i],INFINITE); //   
// ,     .    test   
//  "",     1  
//  
end;
end;

//  
procedure Philosophers.eat;
begin
sleep(Random(5000));  //    5 .
end;

//       
procedure Philosophers.put_stick;
var i, left, right:integer;
Sh:TShape;
begin
i:=FindNumber;
Sh:=TShape(Form1.FindComponent('F'+IntToStr(i)+'Shape'));
EnterCriticalSection(CriticalSection); //    
//WaitForSingleObject(mutex,INFINITE); //     
try
state[i]:=phThinking;  // ,   
Sh.Brush.Color:=clYellow;
left:=i+1;   //    ...
if left=6 then left:=1;
right:=i-1;
if right=0 then right:=5;
test(left);  //  ,      ...
test(right); //  
finally
LeaveCriticalSection(CriticalSection); //    
//ReleaseMutex(mutex);                 //     
end;
end;

//      
procedure Philosophers.test(i:integer);
var left, right:integer;
Sh:TShape;
begin
left:=i+1; //  
if left=6 then left:=1;
right:=i-1;
if right=0 then right:=5;
//   ,    (     ) ...
if (state[i]=phHungry) and (state[left]<>phEating) and (state[right]<>phEating)
  then begin state[i]:=phEating; // ,   
             Sh:=TShape(Form1.FindComponent('F'+IntToStr(i)+'Shape'));
             Sh.Brush.Color:=clAqua;
             ReleaseSemaphore(semaphore[i],1,nil); //  
             //     
       end;
end;
//  ,     
//  .
function Philosophers.FindNumber:integer;
var i:integer;
begin
for i:=1 to 5 do
   if PHID[i]=ThreadID then begin FindNumber:=i; break; end;
end;

end.

