unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
      ExtCtrls, StdCtrls
;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    F1Shape: TShape;
    Shape1: TShape;
    F5Shape: TShape;
    F4Shape: TShape;
    F3Shape: TShape;
    F2Shape: TShape;
    Shape4: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
    mode=(phThinking, phHungry, phEating); //   - , ,
  // 
var
  Form1: TForm1;
  Ph:array [1..5] of TThread; //   -    
  PHID:array [1..5] of Cardinal; //  
  semaphore:array [1..5] of THandle; //  -    
  CriticalSection: TRTLCriticalSection; //  
//  mutex:THandle;                      //  
  state: array [1..5] of mode;          //  




implementation
uses Philosofer;

{$R *.dfm}

//  
procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
begin
for i:=1 to 5 do
ph[i].Resume;
Button1.Enabled:=false;
Button2.Enabled:=true;
end;



procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
Randomize;
for i:=1 to 5 do begin
ph[i]:=Philosophers.Create(true); //  5  (   )
//      false
PHID[i]:=ph[i].ThreadID;  //    (..  
                          // 
semaphore[i]:=CreateSemaphore(nil,0,5,Pchar('semaphore'+IntToStr(i)));
//     
state[i]:=phThinking; //     
end;
InitializeCriticalSection(CriticalSection); //   
//        ( 
//   )
//mutex:=CreateMutex(nil,false,'mutex'); //    ( 
//   )
end;



procedure TForm1.Button2Click(Sender: TObject);
var i:integer;
begin
for i:=1 to 5 do begin
ph[i].Suspend;
end;
Button1.Enabled:=true;
Button2.Enabled:=false;
end;


//   -  ,    (  )
procedure TForm1.FormDestroy(Sender: TObject);
var i:integer;
begin
for i:=1 to 5 do begin
ph[i].Terminate;
ph[i]:=nil;
CloseHandle(semaphore[i]);
end;
DeleteCriticalSection(CriticalSection);
//CloseHandle(mutex);
end;


end.
